﻿Type=Service
Version=2.25
StartAtBoot=True
@EndOfDesignText@
'Service module
Sub Process_Globals
	Dim Notification1 As Notification
	Dim UploadTimer As Timer 
	Dim ActivityCheck As Timer 
	Dim JobNameStr As String 
	Dim ZipFileName As String 
	Dim SQL1 As SQL
	Dim Swap As Boolean 
	Dim UploadInProg As Int 
	
End Sub
Sub Service_Create
	Dim Qstr As String 
	Notification1.Initialize
	Notification1.Sound = False
	Service.StartForeground(1,Notification1)
	StartServiceAt("", DateTime.Now + 2 * DateTime.TicksPerMinute, True)

	UploadTimer.Initialize("UploadTimer",1500)
	UploadTimer.Enabled=True
	
	ActivityCheck.Initialize("ActivityCheck",60000)
	ActivityCheck.Enabled=True
	
	SQL1.Initialize(File.DirRootExternal & "/Download/a3a/", "a3a_cam.db",True)
	SQL1.ExecNonQuery("CREATE TABLE IF NOT EXISTS FilesToSend (file TEXT , status TEXT )") ' Create the table if not there already. 
	
		'Reset all files a wait now	'Update all records as waiting.
			 SQL1.BeginTransaction
				Try				
						Qstr = "UPDATE FilesToSend SET status = ?"
						SQL1.ExecNonQuery2(Qstr, Array As Object("WAITING"))
						SQL1.TransactionSuccessful
			    Catch
			        Log(LastException.Message)
			    End Try
			SQL1.EndTransaction
End Sub

Sub Service_Start (StartingIntent As Intent)
	Dim FilesInProg As Int 
	Dim Qstr As String 
	Dim Filelist As List
	Dim FilesWaiting As Int 
	DoEvents
StartServiceAt("", DateTime.Now + 2 * DateTime.TicksPerMinute, True)
	UploadTimer.Initialize("UploadTimer",500)
	UploadTimer.Enabled=True

	File.MakeDir(File.DirRootExternal & "/Download/a3a", "Images")
	Filelist = File.ListFiles(File.DirRootExternal & "/Download/a3a/Images/")
	
	FilesWaiting = SQL1.ExecQuerySingleResult("SELECT count(*) FROM FilesToSend WHERE status = 'WAITING'")
	If FilesWaiting < 1 AND Filelist.Size > 1 Then 
			'Looks like the DB says no file pending for upload and file count is more than 1
			'this means we add back all those listed files into the DB as new uploads..
			 SQL1.BeginTransaction
				Try					 
					For ik = 0 To Filelist.Size -1
						Qstr = "INSERT INTO FilesToSend VALUES('" & Filelist.Get(ik) & "','WAITING')"
						SQL1.ExecNonQuery(Qstr)
					Next
					SQL1.TransactionSuccessful
			    Catch
			        Log(LastException.Message)
			    End Try
			SQL1.EndTransaction
	End If
	


End Sub

Sub Service_Destroy
StartServiceAt("", DateTime.Now + 1 * DateTime.TicksPerMinute, True)	
End Sub

Sub ActivityCheck_tick
Try

If IsPaused(Main) = True Then 
	StartActivity(Main)
	Log("Activity re-started again")	
End If

Catch
	Return
End Try	

'UploadInProg = 0

End Sub


Sub UploadTimer_Tick
UploadFile
End Sub


Public Sub UploadFile
	Dim n As Int
	Dim ik As Int 
	Dim FilesWaiting As Int 
	Dim FilesInProg As Int 
	Dim Cursor1 As Cursor
	Dim Filename As String 
	Dim CurStatus As String 
	Dim Qstr As String 
	
FilesWaiting = SQL1.ExecQuerySingleResult("SELECT count(*) FROM FilesToSend WHERE status = 'WAITING'")
'CallSubDelayed2(Main,"ShowFilesInQue", FilesWaiting)
If FilesWaiting < 1 Then 
		Return ' Silently exit as there no files pending for upload
End If
'FilesInProg = SQL1.ExecQuerySingleResult("SELECT count(*) FROM FilesToSend WHERE status = 'UPLOADING'")
'CallSubDelayed2(Main,"ShowFilesInUploadQue", FilesInProg)
Cursor1 = SQL1.ExecQuery2("SELECT file FROM FilesToSend WHERE status = ?", Array As String("WAITING"))
'## Every time we execute the upload we take one file from top of the query result and 
'## next time we take the bottom most result. In this way we will have the latest + the oldest files pending for upload in a balanced way
If Swap = False Then
		Cursor1.Position = 0
		Filename = Cursor1.GetString("file")
		Cursor1.Close
		Swap = True
		'ToastMessageShow("UPLOADING TOP MOST", False)
Else
	Cursor1.Position = Cursor1.RowCount -1
		Filename = Cursor1.GetString("file")
		Cursor1.Close
		Swap = False	
		'ToastMessageShow("UPLOADING BOTTOM MOST", False)
End If
	 	'Create the output folder if it does not exist
	File.MakeDir(File.DirRootExternal,"Download/a3a/Images/")

If File.Exists (File.DirRootExternal & "/download/a3a/Images/", Filename) Then
	CallSubDelayed2(Main,"ShowFilesInUploadQue", UploadInProg)
	If UploadInProg < 21 Then
				Dim job2 As HttpJob
				job2.Initialize(Filename,Me)
				job2.PostFile("http://www.abc.com/abc.php?filename=" & Filename,File.DirRootExternal & "/download/a3a/Images/", Filename)
				
			'Update DB
				Qstr = "UPDATE FilesToSend SET status = ? WHERE file = ?"
				SQL1.ExecNonQuery2(Qstr, Array As Object("UPLOADING", Filename))
			'Increment the uploadcounter by 1
			UploadInProg = UploadInProg + 1
	Else
		ToastMessageShow("20 Uploads in Que.Exiting " ,False)
	End If
				
Else
'File does not exist physically. So delete the DB record
	Qstr = "DELETE FROM FilesToSend WHERE file = ?"
	SQL1.ExecNonQuery2(Qstr, Array As Object(Filename))			

End If

End Sub




Sub JobDone (Job As HttpJob)

Dim Filename As String 
Dim Qstr As String 
	'Log("JobName = " & Job.JobName & ", Success = " & Job.Success)
	If Job.Success = True Then
			  	DateTime.TimeFormat = "HH:mm:ss"
				File.WriteString(File.DirRootExternal & "/Download/a3a/","camupdate",DateTime.Time(DateTime.Now))
				Filename = Job.GetString
				Filename = Filename.Trim 
				File.Delete (File.DirRootExternal & "/download/a3a/Images/",Filename)
				'Update DB
				Qstr = "DELETE FROM FilesToSend WHERE file = ?"
				SQL1.ExecNonQuery2(Qstr, Array As Object(Filename))							
				ToastMessageShow("Upload Ok: " & Filename ,False)
				'Decrement one  in the upload counter
				UploadInProg = UploadInProg - 1
				UploadFile ' Call the upload file sub again once we have a confirmation
	Else
				'Update DB
				Filename = Job.JobName 
				Qstr = "UPDATE FilesToSend SET status = ? WHERE file = ?"
				SQL1.ExecNonQuery2(Qstr, Array As Object("WAITING", Filename))			
				ToastMessageShow("Error Uploading: " & Filename, False)
				'UploadFile ' Call the upload file sub again once we have a confirmation
				'Decrement one  in the upload counter
				UploadInProg = UploadInProg - 1

	End If
	Job.Release
End Sub


